Subject: Re: best git practices, was Re: Git User's Survey 2007 unfinished summary continued

From: Andreas Ericsson <[email-masked]>
Date: Wed, 24 Oct 2007 23:06:24 +0200

J. Bruce Fields wrote:
> On Wed, Oct 24, 2007 at 10:12:29PM +0200, Steffen Prohaska wrote:
>> On Oct 24, 2007, at 9:48 PM, J. Bruce Fields wrote:
>>
>>>> I want git pull to work like git push.
>>> That strikes me as a less complete solution, since it only helps in the
>>> case where the other branches all happen to be unmodified locally (hence
>>> can be fast-forwarded).  In other cases the "git push" will still emit a
>>> spurious error.
>> Well, but then there's something you should really think
>> about.
> 
> Perhaps, but not necessarily; you may have some branches with local
> changes that you're content to leave unpushed (and un-updated).
> 

Sure, but that won't change. The only thing I'm proposing is that
local copies of remote branches are automatically fast-forwarded
on every pull, but only if

* the branch has no modifications what so ever
* the branch is set up to auto-merge with the particular branch
fetched from the particular remote

I really don't see any downsides what so ever with this. Those
of you who do, please enlighten me.

> 	- the user has one or more unmodified copies of remote branches
> 	  lying around, and

Extremely common case for a large group of users. The worst part is
that this problem can get extremely annoying pretty quickly, with a
large number of repos and a large number of branches, whereas the
one dev per repo folks will never have big worries about it.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231